Page MenuHomeFreeBSD

Some more basic flavors work.
ClosedPublic

Authored by mat on Oct 3 2017, 4:47 PM.

Details

Reviewers
bapt
bdrewery
Group Reviewers
portmgr
Commits
rP455205: Generic FLAVORS work.

Diff Detail

Lint
No Linters Available
Unit
No Unit Test Coverage
Build Status
Buildable 12226
Build 12518: arc lint + arc unit

Event Timeline

There are a very large number of changes, so older changes are hidden. Show Older Changes
mat updated this revision to Diff 33684.Oct 4 2017, 1:36 PM
  • Move the flavors sanity checks a bit later.
mat updated this revision to Diff 33688.Oct 4 2017, 1:48 PM

rebase.

bapt accepted this revision.Oct 4 2017, 1:50 PM
This revision is now accepted and ready to land.Oct 4 2017, 1:50 PM
mat updated this revision to Diff 33920.Oct 12 2017, 5:07 PM
  • Add a target showing the different package names of a port.
This revision now requires review to proceed.Oct 12 2017, 5:07 PM
mat updated this revision to Diff 33943.Oct 13 2017, 12:24 PM
  • Add a non pretty target to be used in qa checks.
mat updated this revision to Diff 33946.Oct 13 2017, 12:44 PM
  • Add a qa check for unique package names amongst flavors.

Its output is something like:

Error: Package names are not uniques with flavors:
python2: b2-0.7.2
python3: b2-0.7.2
Error: maybe use <flavor>_PKGNAMEPREFIX/SUFFIX.
bapt accepted this revision.Oct 13 2017, 2:41 PM
This revision is now accepted and ready to land.Oct 13 2017, 2:41 PM
mat updated this revision to Diff 34100.Oct 18 2017, 1:12 PM
  • Make MOVEDlint understand flavors.
This revision now requires review to proceed.Oct 18 2017, 1:12 PM
mat updated this revision to Diff 34186.Oct 20 2017, 4:07 PM
  • Be a bit more verbose about which FLAVOR is defined when none should be.
  • Fix fetch-specials when flavors are in play.
mat updated this revision to Diff 34188.Oct 20 2017, 4:48 PM
  • fix make clean FLAVOR=xxx
mat updated this revision to Diff 34189.Oct 20 2017, 4:53 PM

remove last commit.

mat updated this revision to Diff 34325.Oct 25 2017, 2:23 PM

rebase.

mat updated this revision to Diff 34398.Oct 27 2017, 3:29 PM
  • Add a bit of sanity check to make sure FLAVORS stay lowercase.
mat updated this revision to Diff 34453.Oct 30 2017, 11:29 AM

rebase & squash.

mat updated this revision to Diff 34457.Oct 30 2017, 1:59 PM

rebase after MOVEDlint update.

mat added inline comments.Oct 30 2017, 2:26 PM
Mk/bsd.port.mk
1461

So, this works just fine on FreeBSD 11.x, but does not work at all on FreeBSD 10.3.

Any ideas on how I can make this work ?

mat updated this revision to Diff 34544.Oct 31 2017, 3:31 PM
  • Make the bad FLAVORS name work on 10.
mat updated this revision to Diff 34675.Nov 2 2017, 3:07 PM

rebase

mat updated this revision to Diff 35031.Nov 10 2017, 12:39 PM
  • Add support for flavors in the from field.
mat updated this revision to Diff 35192.Nov 13 2017, 2:30 PM
  • Add a tentative CHANGES entry.
  • Forbid using "all" as a flavor name.
allanjude added inline comments.
CHANGES
16 ↗(On Diff #35192)

Flavors are a way to have multiple variants of a port.

mat marked an inline comment as done.Nov 24 2017, 1:04 PM
mat updated this revision to Diff 35687.Nov 24 2017, 1:06 PM
  • fixup! Add a tentative CHANGES entry.
bdrewery requested changes to this revision.Nov 28 2017, 11:47 PM
bdrewery added a subscriber: bdrewery.
bdrewery added inline comments.
CHANGES
25 ↗(On Diff #35687)

"pass the FLAVOR as an argument after make". Your example is not environment, and as far as I can tell it is safer to use it as an argument rather than as environment anyway.

16 ↗(On Diff #35192)

I don't think we should use the word 'variant' anywhere as then people ask "Why not call them variants?? I will just do that anyway". And there is prior art for "variant" in macports which seems to be analogous to our OPTIONS and not FLAVORS.

Mk/bsd.port.mk
1462

Perfect, thanks!

4334

Is DESCRIBE_FLAVORED intended to be DESCRIBE_FLAVORS here and below? The phrase "describe flavored" doesn't make sense to me :)

4353

Pass FLAVOR as a make argument please

4637

.PHONY

4643

Pass FLAVOR as a make argument please

4647

.PHONY

4652

Pass FLAVOR as a make argument please

This revision now requires changes to proceed.Nov 28 2017, 11:47 PM
mat marked 2 inline comments as done.Nov 29 2017, 11:30 AM
mat added inline comments.
CHANGES
16 ↗(On Diff #35192)

I am at a loss of synonyms, what would you want me to use ? I can't use flavor again because I cannot define some word with itself, "version" would be bad...

Mk/bsd.port.mk
4334

It may be frenglish :-)
Maybe it should have been FLAVORED_DESCRIBE.

4353

It is passed as a make argument, is it not ?

4637

I guess many many targets are missing .PHONY here, no ?

4643

It is a make argument, isn't it ?

4652

it is, no ?

mat updated this revision to Diff 35949.Nov 29 2017, 11:41 AM
  • Small fixes.
adamw added a subscriber: adamw.Nov 29 2017, 1:46 PM
adamw added inline comments.
CHANGES
18 ↗(On Diff #35949)

to the flavors

32 ↗(On Diff #35949)

Be sure to guard against an empty FLAVOR variable by using ${FLAVOR:U}:

16 ↗(On Diff #35192)

I'm not sure that "variant" will be confused for OPTIONS, because we've been pretty clear on what OPTIONS are in FreeBSD for many years.

But if not variants: configurations, variations, forms, arrangements.

mat marked 5 inline comments as done.Nov 29 2017, 1:57 PM
mat updated this revision to Diff 35955.Nov 29 2017, 2:34 PM
  • More fixes.
bdrewery accepted this revision.Nov 29 2017, 10:31 PM

DESCRIBE_FLAVORED is still weird but otherwise ship it.

Mk/bsd.port.mk
4334

maybe DESCRIBED_FLAVOR ?

4353

oops

This revision is now accepted and ready to land.Nov 29 2017, 10:31 PM
This revision was automatically updated to reflect the committed changes.